"use strickt";

//  Теоретичні питання
//  1. Опишіть своїми словами як працює метод forEach.

// Це вбудована callback функція JS яка виконує цикл один раз, для кожного елемента в масиві. Ця функція може приймати три аргументи: елемент масиву, індекс поточного елемента та сам масив.

//  2. Які методи для роботи з масивом мутують існуючий масив, а які повертають новий масив? Наведіть приклади.

// Методи, які мутують існуючий масив:

// push(): Додає елементи в кінець масиву:
const arr = [1, 2, 3];
arr.push(4);
console.log(arr); // [1, 2, 3, 4]

//pop(): Видаляє останній елемент масиву:
const arr1 = [1, 2, 3];
arr.pop();
console.log(arr); // [1, 2]

// shift(): Видаляє перший елемент масиву:
const arr2 = [1, 2, 3];
arr.shift();
console.log(arr); // [2, 3]

// unshift(): Додає елементи в початок масиву:
const arr3 = [2, 3];
arr.unshift(0, 1);
console.log(arr); // [0, 1, 2, 3]

// splice(): Додає, видаляє або замінює елементи масиву:
const arr4 = [1, 2, 3, 4, 5];
arr.splice(2, 1, "a", "b");
console.log(arr); // [1, 2, 'a', 'b', 4, 5]

// Методи, які повертають новий масив:

// slice(): Повертає новий масив, який містить копію частини масиву:
const arr5 = [1, 2, 3, 4, 5];
const newArr = arr.slice(1, 3);
console.log(newArr); // [2, 3]

// concat(): Повертає новий масив, який складається з об'єднання декількох масивів:
const arr6 = [1, 2];
const arr7 = [3, 4];
const newArr1 = arr6.concat(arr7);
console.log(newArr1); // [1, 2, 3, 4]

// filter(): Повертає новий масив, що містить тільки елементи, для яких функція зворотнього виклику повертає true:

const arr8 = [1, 2, 3, 4, 5];
const newArr2 = arr8.filter((item) => item % 2 === 0);
console.log(newArr2); // [2, 4]

//  3. Як можна перевірити, що та чи інша змінна є масивом?

// Array.isArray(): Цей метод перевіряє, чи є об'єкт масивом. Він повертає true, якщо змінна є масивом, і false у протилежному випадку.

// За допомогою оператора `instanceof`: Цей оператор перевіряє, чи є об'єкт екземпляром конкретного класу. В даному випадку ми перевіряємо, чи є змінна екземпляром класу `Array`.
// Метод `Array.isArray()` є більш прямолінійним і зручним для використання в багатьох випадках.

//  4. В яких випадках краще використовувати метод map(), а в яких forEach()?

// Потрібно створити новий масив на основі існуючого: map() призначений саме для цього. Він перебирає кожен елемент масиву і застосовує передану функцію до кожного елементу, створюючи новий масив з результатами цих викликів.
const numbers = [1, 2, 3];
const doubled = numbers.map((num) => num * 2);
console.log(doubled); // [2, 4, 6]

// Потрібно привести масив до нового формату або змінити його структуру: Коли потрібно змінити структуру масиву або кожного його елементу, map() є чудовим вибором
const people = [
  { name: "Alice", age: 30 },
  { name: "Bob", age: 25 },
];
const names = people.map((person) => person.name);
console.log(names); // ['Alice', 'Bob']

// forEach():

// Проста ітерація по елементам масиву: forEach() корисний, коли вам просто потрібно пройтися по кожному елементу масиву і виконати якусь операцію без створення нового масиву.

const numbers1 = [1, 2, 3];
numbers1.forEach((num) => console.log(num));
// 1
// 2
// 3

// Модифікація оригінального масиву: Якщо вам потрібно змінити елементи в оригінальному масиві, forEach() буде кращим варіантом, оскільки він не повертає нового масиву.
const numbers2 = [1, 2, 3];
numbers.forEach((num, index, array) => {
  array[index] = num * 2;
});
console.log(numbers2); // [2, 4, 6]

//  Практичні завдання
//  1. Створіть масив з рядків "travel", "hello", "eat", "ski", "lift" та обчисліть кількість рядків з довжиною більше за 3 символи. Вивести це число в консоль.

let words = `travel, hello, eat, ski, lift`;
let wordsArr = words.split(`, `);

let longWords = wordsArr.filter(function (wordsArr) {
  return wordsArr.length > 3;
});

console.log(longWords.length);

//  2. Створіть масив із 4 об'єктів, які містять інформацію про людей: {name: "Іван", age: 25, sex: "чоловіча"}. Наповніть різними даними. Відфільтруйте його, щоб отримати тільки об'єкти зі sex "чоловіча".
//  Відфільтрований масив виведіть в консоль.

const personArr = [
  { name: "Іван", age: 25, sex: "чоловіча" },
  { name: "Лілія", age: 31, sex: "жіноча" },
  { name: "Платон", age: 26, sex: "чоловіча" },
  { name: "Сократ", age: 23, sex: "чоловіча" },
];

let filterPersonArr = personArr.filter(function (personArr) {
  return personArr.sex === `чоловіча`;
});

console.log(filterPersonArr);

//  3. Реалізувати функцію фільтру масиву за вказаним типом даних. (Опціональне завдання)

// Технічні вимоги:

// - Написати функцію filterBy(), яка прийматиме 2 аргументи. Перший аргумент - масив, який міститиме будь-які дані, другий аргумент - тип даних що треба прибрати з масиву.
// - Функція повинна повернути новий масив, який міститиме всі дані, які були передані в аргумент, за винятком тих, тип яких був переданий другим аргументом. Тобто якщо передати масив ['hello', 'world', 23, '23', null], і другим аргументом передати 'string', то функція поверне масив [23, null].

function filterBy(anyArr, deletVal) {
  return anyArr.filter((item) => typeof item !== deletVal);
}
const testArr = ["hello", "world", 23, "23", null];
const filteredArr = filterBy(testArr, "string");
console.log(filteredArr);
